package com.emsoft.exceptions

import com.emsoft.common.Helper

class ErrorCode {

    private static final def sync = new Object()
    private static final def codes = new ArrayList<ErrorCode>()

    public static final ErrorCode OK = new ErrorCode(0)
    public static final ErrorCode INTERNAL_ERROR = new ErrorCode(500)

    private int value

    protected ErrorCode(int value) {
        if (codes.any { c -> c.value == value })
            ExHelper.throwValueAlreadyExists(value)

        this.value = value
        codes << this
    }

    int getValue() {
        return value
    }

    static final synchronized ErrorCode getErrorCode(int value, ErrorCode unknownErrorCode) {
        def code = codes.find { c -> c.value == value }
        return Helper.getValue(code, unknownErrorCode)
    }

    static synchronized ErrorCode getOrCreate(int value) {
        def code = codes.find { c -> c.value == value }
        if (!code)
            return new ErrorCode(value)
        return code
    }
}
