package com.emsoft.exceptions

import com.emsoft.common.Assert

class InternalException extends BaseRuntimeException {

    ErrorCode code

    InternalException(ErrorCode errorCode) {
        super()
        Assert.notNull(errorCode, "errorCode")

        this.code = errorCode
    }

    InternalException(ErrorCode errorCode, Throwable cause) {
        super(cause)
        Assert.notNull(errorCode, "errorCode")
    }

    InternalException(ErrorCode errorCode, String message) {
        super(message)
        Assert.notNull(errorCode, "errorCode")

        this.code = errorCode
    }

    InternalException(ErrorCode errorCode, String message, Throwable cause) {
        super(message, cause)
        Assert.notNull(errorCode, "errorCode")

        this.code = errorCode
    }

    private void setCode(ErrorCode value) {
        this.code = value
    }
}
