package com.emsoft.observer;

import com.emsoft.events.EventArgs;

/**
 * @author Vladimir Zhukov
 * @param < TObserver >
 * @param < TEventAgr >
 */
public interface Observable<TObserver extends Observer<TEventAgr>, TEventAgr extends EventArgs<?, ?>> {

    void subscribe(TObserver observer);

    void unsubscribe(TObserver observer);

    void unsubscribeAll();

    void notifyObservers(TEventAgr arg);
}